import 'package:firebase_messaging/firebase_messaging.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:http/http.dart' as http;
import 'package:encrypt/encrypt.dart' as EncryptPack;
import 'package:crypto/crypto.dart' as CryptoPack;
import 'dart:convert' as ConvertPack;
import 'pnfpbglobalvariables.dart';

class PushNotificationsManager {

  PushNotificationsManager._();


  factory PushNotificationsManager() => _instance;

  static final PushNotificationsManager _instance = PushNotificationsManager._();

  final FirebaseMessaging _firebaseMessaging = FirebaseMessaging.instance;
  bool _initialized = false;


  Future<void> myBackgroundMessageHandler(RemoteMessage message) async {
      // If you're going to use other Firebase services in the background, such as Firestore,
      // make sure you call `initializeApp` before using other Firebase services.
      //print("Handling a background message: ${message.messageId}");
    }

  Future<void> init() async {
    //if (!_initialized) {
      // For iOS request permission first.
      //await Firebase.initializeApp();
      NotificationSettings settings = await _firebaseMessaging.requestPermission(
        alert: true,
        announcement: false,
        badge: true,
        carPlay: false,
        criticalAlert: false,
        provisional: false,
        sound: true,
      );

      print('User granted permission: ${settings.authorizationStatus}');


      FirebaseMessaging.onBackgroundMessage(myBackgroundMessageHandler);

      FirebaseMessaging.onMessage.listen((RemoteMessage message) async {
        print('Got a message whilst in the foreground!');
        //print('Message data: ${message.data.toString()}');

        if (message.notification != null) {
          print('Message also contained a notification: ${message.notification!.title}');
          print('Message also contained a notification: ${message.notification!.body}');
        }
      });

      // For testing purposes print the Firebase Messaging token
      String? token = await _firebaseMessaging.getToken( vapidKey: "BKtlgvPRH639e3MmhIut7CenArfYK2KqWJkXAP3wz_5txFyXtBZ0rnbCDFFrC2rqjA7SQApDBTmVuvKrm-8-wXk");
      //print("FirebaseMessaging token: $token");
      /*Fluttertoast.showToast(
          msg: token.toString(),
          toastLength: Toast.LENGTH_LONG,
          gravity: ToastGravity.CENTER,
          timeInSecForIosWeb: 15,
          fontSize: 16.0
      );*/

      String strPwd = "1c095925a3f5fb27548cd09b2bc37293";

      GlobalData.pushtoken = token.toString();

      final iv = EncryptPack.IV.fromLength(16);

      final key = EncryptPack.Key.fromUtf8(strPwd); //hardcode

      final encrypter = EncryptPack.Encrypter(EncryptPack.AES(key, mode: EncryptPack.AESMode.cbc));

      final encrypted = encrypter.encrypt(token.toString(), iv: iv);

      var hmacSha256 = CryptoPack.Hmac(CryptoPack.sha256,ConvertPack.utf8.encode(strPwd)); // HMAC-SHA256

      var hmacstring = hmacSha256.convert(ConvertPack.utf8.encode(token.toString()));

      var encryptedsubscription = encrypted.base64+":"+iv.base64+":"+hmacstring.toString()+":"+hmacstring.toString();

      var url = Uri.parse('https://www.muraliwebworld.com/wp-json/PNFPBpush/v1/subscriptiontoken');

      var response = await http.post(url, body: {'token': encryptedsubscription});

      var outputresponse = response.statusCode.toString()+' '+response.body;

      /*Fluttertoast.showToast(
          msg: outputresponse,
          toastLength: Toast.LENGTH_LONG,
          gravity: ToastGravity.CENTER,
          timeInSecForIosWeb: 35,
          fontSize: 16.0
      );*/

      _initialized = true;

  }
}