import 'package:flutter/material.dart';
import 'dart:io';
import 'package:webview_flutter/webview_flutter.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'pnfpbglobalvariables.dart';
import 'package:http/http.dart' as http;
import 'package:encrypt/encrypt.dart' as EncryptPack;
import 'package:crypto/crypto.dart' as CryptoPack;
import 'dart:convert' as ConvertPack;

class WebViewContainer extends StatefulWidget {
  final url;
  WebViewContainer(this.url);
  @override
  createState() => _WebViewContainerState(this.url);
}

class _WebViewContainerState extends State<WebViewContainer> {
  var _url;
  final _key = UniqueKey();
  late WebViewController _pnfpbController;
  _WebViewContainerState(this._url);
  @override
  Widget build(BuildContext context) {
    return Scaffold(
        body: Column(
          children: [
            Expanded(
                child: WebView(
                    key: _key,
                    javascriptMode: JavascriptMode.unrestricted,
                    onWebViewCreated: (controller){
                      _pnfpbController = controller;
                    },
                    initialUrl: _url,
                    javascriptChannels: {
                      JavascriptChannel(
                        name: 'unsubscribeGroupid',
                        onMessageReceived: (JavascriptMessage message) async {
                          // Here you can take message.message and use
                          // your string from webview
                          /*Fluttertoast.showToast(
                              msg: message.message.toString(),
                              toastLength: Toast.LENGTH_LONG,
                              gravity: ToastGravity.CENTER,
                              timeInSecForIosWeb: 25,
                              fontSize: 16.0
                          );*/

                          String strPwd = "1c095925a3f5fb27548cd09b2bc37293";

                          var groupid = message.message.toString();

                          final iv = EncryptPack.IV.fromLength(16);

                          final key = EncryptPack.Key.fromUtf8(strPwd); //hardcode

                          final encrypter = EncryptPack.Encrypter(EncryptPack.AES(key, mode: EncryptPack.AESMode.cbc));

                          final encrypted = encrypter.encrypt(GlobalData.pushtoken.toString(), iv: iv);

                          var hmacSha256 = CryptoPack.Hmac(CryptoPack.sha256,ConvertPack.utf8.encode(strPwd)); // HMAC-SHA256

                          var hmacstring = hmacSha256.convert(ConvertPack.utf8.encode(GlobalData.pushtoken.toString()));

                          var encryptedsubscription = encrypted.base64+":"+iv.base64+":"+hmacstring.toString()+":"+hmacstring.toString();

                          var url = Uri.parse('https://www.muraliwebworld.com/wp-json/PNFPBpush/v1/subscriptiontoken');

                          var response = await http.post(url, body: {'token': encryptedsubscription,
                            'subscription-type':'unsubscribe-group',
                            'groupid': groupid,
                            'cookievalue': ''
                          });

                          var outputresponse = response.statusCode.toString()+' '+response.body;

                          /*Fluttertoast.showToast(
                              msg: outputresponse,
                              toastLength: Toast.LENGTH_LONG,
                              gravity: ToastGravity.CENTER,
                              timeInSecForIosWeb: 35,
                              fontSize: 16.0
                          );*/

                        },
                      ),
                      JavascriptChannel(
                        name: 'subscribeGroupid',
                        onMessageReceived: (JavascriptMessage message2) async {
                          // Here you can take message.message and use
                          // your string from webview
                          /*Fluttertoast.showToast(
                              msg: message2.message.toString(),
                              toastLength: Toast.LENGTH_LONG,
                              gravity: ToastGravity.CENTER,
                              timeInSecForIosWeb: 15,
                              fontSize: 16.0
                          );*/

                          String strPwd = "1c095925a3f5fb27548cd09b2bc37293";

                          var groupid = message2.message.toString();

                          final iv = EncryptPack.IV.fromLength(16);

                          final key = EncryptPack.Key.fromUtf8(strPwd); //hardcode

                          final encrypter = EncryptPack.Encrypter(EncryptPack.AES(key, mode: EncryptPack.AESMode.cbc));

                          final encrypted = encrypter.encrypt(GlobalData.pushtoken.toString(), iv: iv);

                          var hmacSha256 = CryptoPack.Hmac(CryptoPack.sha256,ConvertPack.utf8.encode(strPwd)); // HMAC-SHA256

                          var hmacstring = hmacSha256.convert(ConvertPack.utf8.encode(GlobalData.pushtoken.toString()));

                          var encryptedsubscription = encrypted.base64+":"+iv.base64+":"+hmacstring.toString()+":"+hmacstring.toString();

                          var url = Uri.parse('https://www.muraliwebworld.com/wp-json/PNFPBpush/v1/subscriptiontoken');

                          var response = await http.post(url, body: {'token': encryptedsubscription,
                            'subscription-type':'subscribe-group',
                            'groupid': groupid,
                            'cookievalue': ''
                          });

                          var outputresponse = response.statusCode.toString()+' '+response.body;

                          /*Fluttertoast.showToast(
                              msg: outputresponse,
                              toastLength: Toast.LENGTH_LONG,
                              gravity: ToastGravity.CENTER,
                              timeInSecForIosWeb: 35,
                              fontSize: 16.0
                          );*/
                        },
                      ),
                    },
                  onProgress: (url) {
                    _pnfpbController.runJavascriptReturningResult('PNFPB_from_Flutter_mobileapp("'+GlobalData.pushtoken+'")').then((value) => print(value));
                  },

                )
            )
          ],
        )
    );
  }
}